<?php
// script from emmanuel vanneau (phpMyAgenda)
// $Id: events.inc.php3, v2.0 2001/01/06 
/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function validate($idevent)
{
	// event validation 
 	$qid 		= db_query("UPDATE events SET valid = 1 WHERE id = $idevent");
	$qide 	= db_query("SELECT contact1, contact2, contact3, contact4, contact5 FROM events WHERE id=$idevent");
	$result = db_fetch_array($qide);
	for($i=1 ; $i<=5 ; $i++)
	{
		if($result["contact".$i] != 0)
		{
			db_query("UPDATE contacts  SET valid = 1 WHERE id =".$result["contact".$i]);
	 		debug("validating contact ".$result["contact".$i]);
		}
	}
	db_free_result($qide);
	
	// date and event validation
	$query 	= "SELECT id , place FROM date WHERE event=$idevent";
	debug("validating date and place for event $idevent");
	$qid 		= db_query($query);
	while ($r = db_fetch_object($qid))
	{
	 	db_query("UPDATE date  SET valid = 1 WHERE id =".$r->id);
	 	debug("validating date ".$r->id);
	 	db_query("UPDATE place SET valid = 1 WHERE id =".$r->place);
	 	debug("validating place ".$r->place);
	 	$qidpc = db_query("SELECT contact1, contact2 , contact3, contact4, contact5 FROM place WHERE id=".$r->place);
		$res = db_fetch_array($qidpc);
		for($i=1 ; $i<=5 ; $i++)
		{
			db_query("UPDATE contacts SET valid=1 WHERE id=".$res["contact".$i]);
		}
 		db_free_result($qidpc);
	}	 
	
	remove_nonvalid_contacts();
	remove_nonvalid_events();
	remove_nonvalid_dates();
	remove_nonvalid_places();
	
	return 0;
}

function remove_nonvalid_events()
{
 	db_query("DELETE FROM events WHERE valid=0");
	debug("removing non valid event");
}

function print_confirmation($idevent)
{
	GetUrl("events.php3" , "mode=add&step=valid&idevent=$idevent");
}

function validate_event_form($frm)
{
  global $CFG,$ME;
 	if(empty($frm["title"]) || empty($frm["description"]))
 	{
	  $frm["type"]    = "<select name=\"type\">"
	          . db_listbox("SELECT id, type FROM eventtype ORDER BY type", $frm["type"])
	          . "</select>";
	  $frm["url"]    = "<select name=\"url\">"
	          . "<option value=0> </option>"
	          . db_listbox("SELECT id, url FROM url ORDER BY url", $frm["url"])
	          . "</select>";
	  $validation = true;
	  $id = $frm["id"];
 		include("templates/event_form.php3");
 		return false;
 	}
 	return true; 	  
}	

function print_add_events_form()
{
  global $CFG,$ME;
  $frm["newmode"] 		= "add";
  $frm["nextstep"] 		= "";
  $frm["type"]      	= "<select name=\"type\">"
                				. db_listbox("SELECT id, type FROM eventtype ORDER BY type", "0")
                				. "</select>";
  $frm["title"]       = "";
  $frm["description"] = "";
  $frm["url"]         = "<select name=\"url\">"
									     . "<option value=0> </option>"
									     . db_listbox("SELECT id, url FROM url ORDER BY url ", "0")
									     . "</select>";
  $frm["newurl"]      = "";
  $frm["contact1"]		=	0;
  $frm["contact2"]		=	0;
  $frm["contact3"]		=	0;
  $frm["contact4"]		=	0;
  $frm["contact5"]		=	0;
  $frm["contactname1"]	=	"";
  $frm["contactname2"]	=	"";
  $frm["contactname3"]	=	"";
  $frm["contactname4"]	=	"";
  $frm["contactname5"]	=	"";
  
  $frm["valid"]				= 0;
  $frm["submit_place"] 		= "Add new date/place";
  $frm["submit_contact"] 	= "Add Organizer";
  $frm["submit_caption"] 	= "Validate";
  $frm["nbdate"]			= 0;
  include("templates/event_form.php3");
}

function print_edit_events_form($id) {
/* print a events form so we can add a edit the selected events */

  global $CFG, $ME;

  /* load up the information for the events */
  $qid = db_query("SELECT * FROM events WHERE  id = $id");
  $frm = db_fetch_array($qid);

  /* set values for the form */
  $frm["newmode"] = "update";
  $frm["type"]    = "<select name=\"type\">"
          . db_listbox("SELECT id, type FROM eventtype ORDER BY type", $frm["type"])
          . "</select>";
  $frm["url"]    = "<select name=\"url\">"
          . "<option value=0> </option>"
          . db_listbox("SELECT id, url FROM url ORDER BY url", $frm["url"])
          . "</select>";

  $frm["submit_caption"] 	= "validate";
  $frm["submit_place"] 		= "Add new date/place";
  $frm["submit_contact"] 	= "Add Organizer";
  $frm["submit_caption"] 	= "Validate";
  
  for($i=1 ; $i<=5 ; $i++)
	{
		$idc 	= $frm["contact".$i];
		$qidc = db_query("SELECT id,name FROM contacts WHERE id = $idc");
		if(db_num_rows($qidc))
		{
			$r = db_fetch_object($qidc);
   		$frm["contactname".$i]	=	$r->name;
   	}
   	else
   		$frm["contactname".$i]	=	"";
  	db_free_result($qidc);
	}
	
  db_free_result($qid);
  $qid = db_query("SELECT * FROM date WHERE event=$id");
  $frm["nbdate"]					= db_num_rows($qid);
  $i=0;
	debug("Editing event $id");
	while ($r = db_fetch_object($qid))
  {
  	$frm["date".$i] 	= dispdate($r->start , $r->end);
  	$frm["dateid".$i] = $r->id;
  	$qid2 = db_query("SELECT name FROM place WHERE id=$r->place");
  	$r2 = db_fetch_object($qid2);
  	$frm["placeid".$i] = $r->place;
  	$frm["place".$i++] = $r2->name;
  }

  include("templates/event_form.php3");
}

function duplicate_events($id){

	$qid = db_query("SELECT * FROM events WHERE  id = $id");
	$frm = db_fetch_array($qid);
	$frm["valid"] = 0;
	$id2 = insert_events($frm , 0);
	db_free_result($qid);
	$qid = db_query("SELECT * FROM date WHERE event = $id");
	while ($frm = db_fetch_array($qid))
	{
		$frm["idevent"] = $id2;
		$frm["idplace"] = $frm["place"];
		$frm["valid"] = 0;
		insert_date($frm);
	}	
	print_edit_events_form($id2);
}


function delete_events($id) {
	global $CFG, $ME;
	
	// remove all dates refering to this event
	delete_date_from_event($id);
	
	/* delete this events */
	$qid = db_query("DELETE FROM events WHERE id = $id");
}

function check_unique_event($frm)
{
//Check that place with fields in $frm is not present in the table
//return : 0 if not present in table
//         place.id if present
	
	$query = "SELECT id FROM events WHERE ";
	$query .= "title='$frm[title]' AND ";
	$query .= "description='$frm[description]' AND ";
	$query .= "url='$frm[url]' AND ";
	$query .= "type='$frm[type]'";
	$qid = db_query($query);
	if($row = mysql_fetch_array ($qid))
	 return $row["id"];
	return 0;
}

function insert_events($frm , $check=1) {
/* add a new subevents under the parent $id.  all the fields that we want are
 * going to in the variable $frm */

  global $CFG, $ME;

  if($check == 1)
  {
    $id = check_unique_event($frm);
    if($id)
    {
      echo "<div class=normal>The event <b>".$frm["title"]."</b> already exists in the database. Using the existing.</div>";
      return $id;
    }
  }
  
  if($frm["url"] == 0 && !empty($frm["newurl"]))
 	{
 		$frm["url"] = insert_url($frm);
 		debug("inserting url ".$frm["newurl"]." as id=".$frm["url"]);
 	}
  $frm["description"]    = addslashes ($frm["description"]);
  $frm["title"]          = addslashes ($frm["title"]);
  $qid = db_query("INSERT INTO events
          (id, title, description, url, type , contact1 , contact2 , contact3 , contact4, contact5)
          VALUES ('', '$frm[title]', '$frm[description]','$frm[url]', '$frm[type]' , '$frm[contact1]', '$frm[contact2]', '$frm[contact3]', '$frm[contact4]', '$frm[contact5]')");
  return db_insert_id();
}

function update_events($id, $frm) {
/* update the events $id with new values.  all the fields that we want are
 * going to in the variable $frm */

  global $CFG, $ME;

  $frm["description"]    = addslashes ($frm["description"]);
  $frm["title"]          = addslashes ($frm["title"]);

  $qid = db_query("
  UPDATE events SET
          title 				= '$frm[title]'
          ,description 	= '$frm[description]'
          ,url 					= '$frm[url]'
          ,type 				= '$frm[type]'
          ,contact1			= '$frm[contact1]'
          ,contact2			= '$frm[contact2]'
          ,contact3			= '$frm[contact3]'
          ,contact4			= '$frm[contact4]'
          ,contact5			= '$frm[contact5]'
  WHERE id = $id
  ");
}

function print_events_list($orderby="" , $selecttype="" , $selectmonth="" , $selectyear="" , $selectmonthend ="", $selectyearend="" , $selectplace="" , $selectcontact="", $edge=0)
{
/* read events from the database with filter and order and print them into a table.  we
 * will use a template to display the listings to keep this main script clean */

	global $CFG, $ME;
	
	if(empty($edge))
	{
	  $edge = 0;
	}
	$limit = 20;
	
	if(!empty($selectmonth))
	 $monthstart = $selectmonth;
	else
	 $monthstart = 1;
	
	if(!empty($selectyear))
	 $yearstart = $selectyear;
	else
	 $yearstart = "";

	if(!empty($selectmonthend))
	 $monthend = $selectmonthend;
	else
	 $monthend = 12;
	
	if(!empty($selectyearend))
	 $yearend = $selectyearend;
	else
	 $yearend = "";

	$selectdate = !empty($selectyear) || !empty($selectmonth) || !empty($selectyearend) || !empty($selectmonthend);
	
	// format the query
	$req_listevents 		 = "SELECT e.id , e.title, e.description, t.type ";
	if($selectdate)
		$req_listevents 	.= ", d.start ";
	if($selectplace)
		$req_listevents 	.= ", p.name ";
	$req_listevents			.= "FROM   events e, eventtype t ";
	if($selectdate || $selectplace)
		$req_listevents 	.= ", date d ";
	if($selectplace)
		$req_listevents 	.= ", place p ";
	$req_listevents 		.= "WHERE  t.id = e.type ";
	        	 
	if(!empty($selecttype))
	  $req_listevents .= " AND e.type=$selecttype ";
	
	
	if($selectdate)
	{
	    $date    = formatSQLdate($yearstart , $monthstart , 1);
	    $dateend = formatSQLdate($yearend , $monthend , 31);
	    $req_listevents .= " AND d.event = e.id AND d.start >='$date' AND d.start <='$dateend'";
	}
	
	if(!empty($selectplace))
	 $req_listevents .= " AND p.id = $selectplace AND d.place = $selectplace AND d.event = e.id ";

	if(!empty($selectcontact))
	 $req_listevents .= " AND (	e.contact1=$selectcontact OR 
	 														e.contact2=$selectcontact OR 
	 														e.contact3=$selectcontact OR 
	 														e.contact4=$selectcontact OR 
	 														e.contact5=$selectcontact) ";
	 
	if($orderby)
	 $req_listevents .= " ORDER BY ".$orderby." ASC";
	
	debug("listing request = $req_listevents");
	// do the query
	$qidnum    = db_query($req_listevents);
	$numevents = db_num_rows($qidnum);
	db_free_result($qidnum);
	$qid       = db_query($req_listevents." LIMIT $edge, $limit");
	
	// formatting filter selectors
	$frm["selecttype"]    = "<select name=\"selecttype\">"
	        . "<option value=''> </option>"
	        . db_listbox("SELECT id, type FROM eventtype ORDER BY type",$selecttype)
	        . "</select>";

	$frm["selectmonth"]   = "<select name=\"selectmonth\">"
	                      . "<option value=''></option>"
												. option_month($selectmonth)
												. "</select>";
	
	$frm["selectmonthend"]= "<select name=\"selectmonthend\">"
	                      . "<option value=''></option>"
												. option_month($selectmonthend)
												. "</select>";
	
	
	$frm["selectyear"]   = "<select name=\"selectyear\">"
	                      . "<option value=''></option>"
												.	option_year($selectyear , 2000 , 2010)
												. "</select>";
	
	$frm["selectyearend"] = "<select name=\"selectyearend\">"
	                      . "<option value=''></option>"
												.	option_year($selectyearend , 2000 , 2010)
												. "</select>";
												
	$frm["selectplace"]		= "<select name=\"selectplace\">"
	                      . "<option value=''></option>"
												.	db_listbox("SELECT id , name FROM place ORDER BY name" , $selectplace)
												. "</select>";

	$frm["selectcontact"]	= "<select name=\"selectcontact\">"
	                      . "<option value=''></option>"
												.	db_listbox("SELECT id, name FROM contacts ORDER BY name" , $selectcontact)
												. "</select>";
	
	include("templates/events_list.php3");
}

function	add_contact_to_event($idevent , $idcontact)
{
	// Add a contact reference to the event
	$qid = db_query("SELECT * FROM events WHERE id=$idevent");
  $r 	 = db_fetch_array($qid);
  $done= false;
  for($i=1 ; $i<=5 && !$done ; $i++)
	{
		$cid = "contact".$i;
		if($r[$cid] == 0)
		{
			db_query("UPDATE events SET $cid = $idcontact WHERE id=$idevent");
			debug("contact event # $i added");
			$done = true;
		}
  }
	db_free_result($qid);
}

function update_contact_to_event($idevent , $idcontact , $idcontactnumber=0)
{
	$cid = "contact".$idcontactnumber;
	debug("updating $cid");
	db_query("UPDATE events SET $cid = $idcontact WHERE id=$idevent");
	debug("contact event # $idcontactnumber updated");
}

function	remove_contact_from_event($idevent , $idcontact)
{
	// remove a contact reference from the event
	$cid = "contact".$idcontact;
	db_query("UPDATE events SET $cid = 0 WHERE id=$idevent");
}

function get_first_events($limit = 5)
{
	$req_listevents 		 = "SELECT e.id , e.title, e.description, t.type , d.start 
													FROM   events e, eventtype t , date d 
													WHERE  t.id = e.type 
													AND d.event = e.id 
													AND d.start >= NOW() 
													ORDER BY d.start ASC
													LIMIT 0 , $limit";
	
	debug("listing request = $req_listevents");
	// do the query
	$qidnum    = db_query($req_listevents);
	return $qidnum;
}

?>