<?php
// script from emmanuel vanneau (phpMyAgenda)
// $Id: eventtype.inc.php3, v2.0 2001/01/06 
/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function print_add_eventtype_form($id) {
/* print a blank event type form so we can add a new events */

        global $CFG,$ME;

        $frm["newmode"]        = "insert";
        $frm["type"]           = "";
        $frm["submit_caption"] = "Add type";

        include("templates/eventtype_form.php3");
}

function get_eventtype($id)
{
        $qid = db_query("SELECT * FROM eventtype WHERE  id = $id");
        return db_fetch_array($qid);
}

function print_edit_eventtype_form($id) {
/* print a eventtype form so we can add a edit the selected events */

        global $CFG, $ME;

        /* load up the information for the eventtype */
        $frm = get_eventtype($id);

        /* set values for the form */
        $frm["newmode"]        = "update";
        $frm["type"]           = $frm["type"];
        $frm["submit_caption"] = "Save Changes";

        include("templates/eventtype_form.php3");
}

function delete_eventtype($id) {
       global $CFG, $ME;

       /* replacing this type in other tables*/
       replace_eventtype($id);

        /* delete this eventtype */
       $qid = db_query("DELETE FROM eventtype WHERE id = $id");
}

function replace_eventtype($id)
{
// used to scan events to get item with eventtype=$id
// replace these items eventtype's with 2(undefined);

   $replaced = replace_in_table("eventtype" , "type" , "$id" , "2");
   if($replaced)
    echo "<div class=normal>The event type has been found in <b>$replaced events</b>. Replacing these events' type with default</div>";
}

function check_unique_eventtype($frm)
{
//Check that eventtype with fields in $frm is not present in the table
//return : 0 if not present in table
//         id if present

        $query = "SELECT id FROM eventtype WHERE ";
        $query .= "type='$frm[type]'";
        $qid = db_query($query);
        if($row = mysql_fetch_array ($qid))
         return $row["id"];
        return 0;
}

function insert_eventtype($frm) {
/* add a new event type.  all the fields that we want are
 * going to in the variable $frm */

        global $CFG, $ME;

        $id = check_unique_eventtype($frm);
        if($id)
        {
          echo "<div class=normal>The event type <b>".$frm["type"]."</b> already exists in the database. Using the existing.</div>";
          return $id;
        }

        $qid = db_query("INSERT INTO eventtype
                (id, type)
                VALUES ('', '$frm[type]')");
        return db_insert_id();
}

function update_eventtype($id, $frm) {
/* update the eventtype $id with new values.  all the fields that we want are
 * going to in the variable $frm */

        global $CFG, $ME;

        $qid = db_query("
        UPDATE eventtype SET
                type = '$frm[type]'
        WHERE id = $id");
}

function print_eventtype_list() {
/* read all the eventtype from the database and print them into a table.  we
 * will use a template to display the listings to keep this main script clean */

        global $CFG, $ME;
        $qid = db_query("SELECT * FROM eventtype ORDER BY type");

        include("templates/eventtype_list.php3");
}
?>