<?php
// script from emmanuel vanneau (phpMyAgenda)
// $Id: url.inc.php3, v2.0 2001/01/06 
/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function print_add_url_form($id) {
/* print a blank url form so we can add a new events */

  global $CFG,$ME;

  $frm["newmode"]        = "insert";
  $frm["newurl"]         = "";
  $frm["submit_caption"] = "Add url";

  include("templates/url_form.php3");
}

function get_url($id)
{
  $qid = db_query("SELECT * FROM url WHERE  id = $id");
  return db_fetch_array($qid);
}

function print_edit_url_form($id) {
/* print a url form so we can add a edit the selected events */

  global $CFG, $ME;

  /* load up the information for the url */
  $frm = get_url($id);

  /* set values for the form */
  $frm["newmode"]        = "update";
  $frm["newurl"]         = $frm["url"];
  $frm["submit_caption"] = "Save Changes";

  include("templates/url_form.php3");
}

function delete_url($id) {
	global $CFG, $ME;
	
	/* replacing this url in other tables*/
	replace_url($id);
	
	/* delete this url */
	$qid = db_query("DELETE FROM url WHERE id = $id");
}

function replace_url($id)
{
// used to scan events, contact and place tables to get item with url=$id
// replace these items url's with 2(No url);

	$replaced = replace_in_table("place" , "url" , "$id" , "2");
	if($replaced)
		echo "<div class=normal>The url has been found in <b>$replaced places</b>. Replacing these places' url with default</div>";
	$replaced = replace_in_table("contacts" , "url" , "$id" , "2");
	if($replaced)
		echo "<div class=normal>The url has been found in <b>$replaced contacts</b>. Replacing these contacts' url with default</div>";
	$replaced = replace_in_table("events" , "url" , "$id" , "2");
	if($replaced)
		echo "<div class=normal>The url has been found in <b>$replaced events</b>. Replacing these events' url with default</div>";
}

function check_unique_url($frm)
{
//Check that place with fields in $frm is not present in the table
//return : 0 if not present in table
//         id if present

	$query = "SELECT id FROM url WHERE ";
	$query .= "url='$frm[newurl]'";
	$qid = db_query($query);
	if($row = mysql_fetch_array ($qid))
	 	return $row["id"];
	return 0;
}

function insert_url($frm) {
/* add a new url.  all the fields that we want are
 * going to in the variable $frm */

	global $CFG, $ME;
	
	$id = check_unique_url($frm);
	if($id)
	{
	  echo "<div class=normal>The url <b>".$frm["newurl"]."</b> already exists in the database. Using the existing.</div>";
	  return $id;
	}
	
	$qid = db_query("INSERT INTO url
	        (id, url)
	        VALUES ('', '$frm[newurl]')");
	return db_insert_id();
}

function update_url($id, $frm) {
/* update the url $id with new values.  all the fields that we want are
 * going to in the variable $frm */

  global $CFG, $ME;

  $qid = db_query("
  UPDATE url SET
          url = '$frm[newurl]'
  WHERE id = $id");
}

function print_url_list() {
/* read all the url from the database and print them into a table.  we
 * will use a template to display the listings to keep this main script clean */

  global $CFG, $ME, $req_listurl;
  $qid = db_query("SELECT * FROM url ORDER BY url");

  include("templates/url_list.php3");
}
?>