<?php
// script from emmanuel vanneau (phpMyAgenda)
// $Id: events.php3, v2.0 2001/01/06 

include("../application.php3");
include("include/auth.inc.php3");
include("include/events.inc.php3");
include("include/place.inc.php3");
include("include/date.inc.php3");
include("include/contacts.inc.php3");
include("include/url.inc.php3");

include("lang/$Auth->language.lang.php3");
$DOC_TITLE = $strEventTitle;
include("templates/header.php3");


switch (nvl($mode)) {
        case "add" :				
        				print_add_events_form(); 
        				break;
        		
        case "select_place" : 	
        				if(!isset($id) || empty($id))
									$id = insert_events($HTTP_POST_VARS); 
								else
									update_events($id , $HTTP_POST_VARS); 
								debug("id event=$id");
								print_select_place_form($id);
								break;
								
        case "selected_place" : 	
								debug("selected place =".$place);
								debug("id event=$id");
								debug("id date = $iddate");
								if(isset($iddate) && $iddate != 0)
											print_edit_date_form($iddate , $place);
								else	print_add_date_form($id , $place , $iddate); 
								break;
								
        case "add_place" : 	
        				if(!isset($id) || empty($id))
									$id = insert_events($HTTP_POST_VARS); 
								debug("id event=$id");
								print_add_place_form($id);
								break;
								
				case "ins_place"	:	
								if(!validate_place_form($HTTP_POST_VARS , "ins_place"))
									break;
								$insert = insert_places($HTTP_POST_VARS , 0);
								debug("id = $idevent");
								debug("place = $insert");
								print_add_date_form($idevent , $insert); 
								break;
								
				case "update_place"	:	
        				debug("updating place form");
								if(!validate_place_form($HTTP_POST_VARS , "update_place"))
									break;
               	update_places($id, $HTTP_POST_VARS);
								debug("id = $idevent");
								debug("place = $id");
								print_add_date_form($idevent , $id); 
								break;
								
        case "ins_date"		:
        				debug("inserting place form");
        				if(!validate_date_form($HTTP_POST_VARS , "ins_date"))
        					break;
        				$HTTP_POST_VARS["start"] = formatSQLdate($startyear ,$startmonth,$startday,$starthour,$startmin);

								format_date_end_as_date($HTTP_POST_VARS);

								$HTTP_POST_VARS["end"] 	 = formatSQLdate($endyear,$endmonth,$endday,$endhour,$endmin);

								insert_date($HTTP_POST_VARS , 0);
								print_edit_events_form($idevent);
								break;
													
								
				case "update_date":
        				if(!validate_date_form($HTTP_POST_VARS , "update_date"))
        					break;
								debug("Updating date $iddate");
        				$HTTP_POST_VARS["start"] = formatSQLdate($startyear ,$startmonth,$startday,$starthour,$startmin);

								format_date_end_as_date($HTTP_POST_VARS);

								$HTTP_POST_VARS["end"] 	 = formatSQLdate($endyear,$endmonth,$endday,$endhour,$endmin);

								update_date($iddate , $HTTP_POST_VARS);
								print_edit_events_form($idevent);
								break;
				
				case "edit_date":
								print_select_place_form($id , $idplace , $iddate);
								break;
								
				case "del_date":
								delete_date($iddate);
								print_edit_events_form($id);
								break;

        case "edit_contact" :
        				if(!isset($id) || empty($id))
									$id = insert_events($HTTP_POST_VARS); 
								else
									update_events($id , $HTTP_POST_VARS); 
								debug("editing contact ".$idcontact);
								debug("id event=$id");								
								print_select_contact_form($id , $idcontact , 0 , "" , 0 , $eventcontact);
								break;
         	
        case "select_contact" : 	
        				if(!isset($id) || empty($id))
									$id = insert_events($HTTP_POST_VARS); 
								else
									update_events($id , $HTTP_POST_VARS); 
								debug("id event=$id");
								print_select_contact_form($id);
								break;
								
        case "selected_contact" : 	
								debug("selected contact =".$contact);
								debug("id event=$idevent");
								if($insert)
									add_contact_to_event($idevent , $contact);
								else
									update_contact_to_event($idevent , $contact , $eventcontact);
								print_edit_events_form($idevent);
								break;
								
        case "add_contact" : 	
        				debug("id event=$id");
								print_add_contact_form($id , 0 , "");
								break;
								
        case "insert_contact" : 	
        				if(!validate_contact_form($HTTP_POST_VARS , "insert_contact"))
        					break;
        				$idcontact = insert_contact($HTTP_POST_VARS , 0);
        				debug("inserting contact $idcontact");
								add_contact_to_event($idevent , $idcontact);
								print_edit_events_form($idevent);
								break;
						
				case "del_contact":
        				if(!isset($id) || empty($id))
									$id = insert_events($HTTP_POST_VARS); 
								else
									update_events($id , $HTTP_POST_VARS); 
								remove_contact_from_event($id , $eventcontact);
								print_edit_events_form($id);
								break;
								
	      case "select_contactplace" : 	
        				if(!isset($id) || empty($id))
									$id = insert_places($HTTP_POST_VARS , 0); 
								else
									update_places($id , $HTTP_POST_VARS);
								debug("id place=$id");
								debug("id event=$idevent");
								print_select_contact_form($idevent , $idcontact , $id , "place");
								break;
								
        case "selected_contactplace" : 	
								debug("selected contact =".$contact);
								debug("id place=$idplace");
								debug("id event=$idevent");
								add_contact_to_place($idplace , $contact);
								print_edit_places_form($idplace , $idevent);
								break;
								
        case "add_contactplace" : 	
        				debug("id event=$id");
								debug("id place=$idplace");
								print_add_contact_form($id , $idplace , "place");
								debug("add contact place");
								break;
								
        case "insert_contactplace" : 	
        				debug("insert contact");
        				if(!validate_contact_form($HTTP_POST_VARS , "insert_contactplace"))
        					break;
        				$contact = insert_contact($HTTP_POST_VARS , 0);
								add_contact_to_place($idplace , $contact);
								print_edit_places_form($idplace , $idevent);
								break;

				case "del_contactplace":
								remove_contact_from_place($id);
								print_edit_places_form($id , $idevent);
								break;

       	case "valid" :
        				if(!validate_event_form($HTTP_POST_VARS))
        					break;
        				if(!isset($id) || empty($id))
									$id = insert_events($HTTP_POST_VARS); 
                else
                	update_events($id, $HTTP_POST_VARS);
       					validate($id); 
								print_events_list("" , "" , "" , "" , 0);
       					break;
       					
        case "edit" :
                print_edit_events_form($id);
                break;

        case "del" :
                delete_events($id);
                print_events_list();
                break;

        case "duplicate" :
                duplicate_events($id);
                break;

	      default :
                if(!isset($orderby))
                 $orderby="";
                if(!isset($selecttype))
                 $selecttype="";
                if(!isset($selectmonth))
                 $selectmonth="";
                if(!isset($selectyear))
                 $selectyear="";
                if(!isset($selectmonthend))
                 $selectmonthend="";
                if(!isset($selectyearend))
                 $selectyearend="";
                if(!isset($selectplace))
                 $selectplace="";
                if(!isset($selectcontact))
                 $selectcontact="";
                if(!isset($edge))
                 $edge=0;
                print_events_list($orderby , $selecttype , $selectmonth , $selectyear , $selectmonthend , $selectyearend , $selectplace , $selectcontact , $edge);
                break;
}

include("templates/footer.php3");


?>