<?php
// script from emmanuel vanneau (phpMyAgenda)
// $Id: admin.inc.php3, v2.0 2001/01/06 
/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function print_add_user_form($id) {
/* print a blank admin form so we can add a new events */

  global $CFG,$ME,$Auth;

  $frm["newmode"]        = "insert";
  $frm["user"]         	 = "";
  $frm["permissions"] 	 = $Auth->fill_permission_option();
  $frm["active"]				 = "";
  $frm["submit_caption"] = "Add user";
	$validation 					 = 0;
  include("templates/admin_form.php3");
}

function get_user($id)
{
  $qid = db_query("SELECT * FROM admin WHERE  id = $id");
  return db_fetch_array($qid);
}

function print_edit_user_form($id) {
/* print a admin form so we can add a edit the selected events */

  global $CFG, $ME, $Auth;

  /* load up the information for the admin */
  $frm = get_user($id);

  /* set values for the form */
  $frm["newmode"]		     = "update";
  $frm["permissions"] 	 = $Auth->fill_permission_option($frm["permissions"]);
	$validation 					 = 0;
  include("templates/admin_form.php3");
}

function delete_user($id) {
	global $CFG, $ME;
	
	/* delete this admin */
	$qid = db_query("DELETE FROM admin WHERE id = $id");
}

function check_unique_user($frm)
{
//Check that place with fields in $frm is not present in the table
//return : 0 if not present in table
//         id if present

	$query = "SELECT id FROM admin WHERE user='$frm[user]'";
	$qid = db_query($query);
	if($row = mysql_fetch_array ($qid))
	 	return $row["id"];
	return 0;
}

function insert_user($frm) {
/* add a new admin.  all the fields that we want are
 * going to in the variable $frm */

	global $CFG, $ME;
	
	if(!isset($frm["active"]))
		$frm["active"] = 0;
 	$id = check_unique_user($frm);
	if($id)
	{
	  echo "<div class=normal>The admin <b>".$frm["user"]."</b> already exists in the database.</div>";
	  return $id;
	}
	
	$frm["pass"] = md5($frm["pass"]);
	$qid = db_query("INSERT INTO admin
	        (id, user , pass , active , permissions)
	        VALUES ('', '$frm[user]', '$frm[pass]', '$frm[active]', '$frm[permissions]')");
	return db_insert_id();
}

function update_user($id, $frm) {
/* update the admin $id with new values.  all the fields that we want are
 * going to in the variable $frm */

  global $CFG, $ME;
	if(!isset($frm["active"]))
		$frm["active"] = 0;
	$frm["pass"] = md5($frm["pass"]);
  $qid = db_query("UPDATE admin SET user='$frm[user]',pass='$frm[pass]',active='$frm[active]',permissions='$frm[permissions]' WHERE id = $id");
}

function print_user_list() {
/* read all the admin from the database and print them into a table.  we
 * will use a template to display the listings to keep this main script clean */

  global $CFG, $ME;
  $qid = db_query("SELECT * FROM admin ORDER BY user");

  include("templates/admin_list.php3");
}

function validate_user_form($frm)
{
	$validation = 0;
  global $CFG,$ME;
 	if(empty($frm["user"]))
 		$validation = 1;
 	if(empty($frm["pass"]) || ($frm["pass"] != $frm["repass"]))
 		$validation = 2;

	if($validation)
	{
		global $Auth;
		if(!isset($frm["active"]))
			$frm["active"] = 0;
  	$frm["permissions"] = $Auth->fill_permission_option($frm["permissions"]);
	  include("templates/admin_form.php3");
		return false;	
	}
	return true;
}	

?>