<?php
// script from emmanuel vanneau (phpMyAgenda)
// $Id: auth.inc.php3, v2.0 2001/01/06 

class Auth
{
  var $acct_table      = 'admin';        // the table your accounts are in
  var $username_col    = 'user';         // the name of the username column
  var $pass_col        = 'pass';         // the name of the password column
  var $status_col      = 'active';       // the name of the active column
  var $lang_col      	 = 'lang';     		 // the name of the lang column
  var $last_col      	 = 'lastlogin';		 // the name of the last login column
  var $perm_col      	 = 'permissions';	 // the name of the permission column
  var $sid_col      	 = 'sid';	 				 // the name of the session id column
	
  var $magicword0      = "Lucida";       // 1st MagicWord to encode cookie value
  var $magicword1      = "Gravement";    // 2nd MagicWord to encode cookis value

	var $login					 = "";						 // login value
	var $language				 = "english";			 // language of this login
	var	$active					 = ""; 						 // active 
	var $sid						 = "";						 // sid of this user
	var $lastlogin			 = "";						 // last login datetime
	var $permissions		 = "read";				 // permissions for this user
	
  var $redirect        = "";
  
  function Init()
  {
    global $HTTP_REFERER;
    global $HTTP_POST_VARS;
    
    if(!isset($HTTP_REFERER))
    	$HTTP_REFERER = "";

    if(!isset($HTTP_POST_VARS))
    	$HTTP_POST_VARS = "";
    	
    if (!isset($HTTP_POST_VARS["redirect"]))
    {
      $this->redirect = $HTTP_REFERER;
    }
    else
    {
      $this->redirect = $HTTP_POST_VARS["redirect"];
    }
  }

	function require_auth($perm="read")
	{
		// Do login
		// perm	check the permission allow to user.
	
		global $login;			// from form
		global $sid;
		
	  if(isset($login))
	  {
			$this->authenticate();
	  }
	  else
	  {
	  	if(!isset($sid))
     	 	$this->show_login_form();
	  	else
	  	{
	   		$qid = db_query("SELECT * FROM $this->acct_table WHERE sid='$sid'");
	   		if(!db_num_rows($qid))
	   		  $this->show_login_form();
				else
				{
 		      $a 								= db_fetch_array($qid);
					$this->login			= $a[$this->username_col];
					$this->language		= $a[$this->lang_col];
					$this->active			= $a[$this->status_col];
					$this->lastlogin	= $a[$this->last_col];
					$this->permissions= $a[$this->perm_col];
					$this->sid				= $a[$this->sid_col];
				}
			}
	  }
	}

  function authenticate()
  {
	
	  // These are the names of the vars from the login form,
	  // so make sure you use them when you create your form
	  // in HTML.
	
	  global $login;
	  global $acct_pass;


		$qid = db_query("SELECT * FROM $this->acct_table WHERE $this->username_col = '$login'");
	  if (db_num_rows($qid) != 1)
			$this->show_login_form("failed");
	  else
	  {
      $a 								= db_fetch_array($qid);
			$this->login			= $a[$this->username_col];
			$this->language		= $a[$this->lang_col];
			$this->active			= $a[$this->status_col];
			$this->lastlogin	= $a[$this->last_col];
			$this->permissions= $a[$this->perm_col];
			$this->sid				= $a[$this->sid_col];
	
			if ($a[$this->pass_col] != md5($acct_pass))
      {
      	debug("pass failed");
      	$this->show_login_form("Login failed");
      }
      elseif ($a[$this->status_col] == 0) 
      {
      	debug("active failed");
      	$this->show_login_form("Profile not active. Contact your administrator");
      }
			else
        $this->set_login_cookie();
	  }
  }

  function set_login_cookie()
  {
	  srand(time());
	  $this->sid = md5(time() + rand(0,10000));
		
		$qid = db_query("UPDATE $this->acct_table SET sid='$this->sid', $this->last_col=NOW() WHERE $this->username_col = '$this->login'");
	 	setcookie("sid" , $this->sid);
  }

  function log_out()
  {
		$qid = db_query("UPDATE $this->acct_table SET sid='', $this->last_col=NOW() WHERE $this->username_col = '$this->login'");
	 	setcookie("sid");
  }

  function show_login_form($failed="")
  {
    global $ME;
    global $redirect;
    
    if(!isset($redirect))
     $redirect="";

    include("login.php3");
    exit;
  }
  
  function can_user_write()
  {
  	return ($this->permissions == "write" || $this->permissions == "admin");
  }
  
  function is_admin()
  {
  	return $this->permissions == "admin";
  }
  
  function fill_permission_option($current = "")
  {
  	global $strRight;
  	if(!isset($strRight))
 			$strRight	= array("admin"=>"Administrator" , "write"=>"Read / Write" , "read"=>"Read only");
  		
  	if(empty($current))
  		$current = $this->permissions;
  	$opt = "<option name='permission' value='admin' ";
 		if($current == "admin")
 			$opt .= " selected ";
 		$opt .= ">$strRight[admin]</option>"; 
  	$opt .= "<option name='permission' value='write' ";
 		if($current == "write")
 			$opt .= " selected ";
 		$opt .= ">$strRight[write]</option>"; 
  	$opt .= "<option name='permission' value='read' ";
 		if($current == "read")
 			$opt .= " selected ";
 		$opt .= ">$strRight[read]</option>"; 
 		return $opt;
 	}
}

//function CheckAuth()
//{
 $Auth = new Auth;
 $Auth->Init();
 $Auth->require_auth();
//}
?>