<?php
/* $Id: tbl_dump.php3,v 1.7 1999/11/16 11:28:12 tobias Exp $ */
//@set_time_limit(600);
$crlf="\n";
header("Content-disposition: filename=$db.sql");
header("Content-type: application/octetstream");
header("Pragma: no-cache");
header("Expires: 0");
// doing some DOS-CRLF magic...
$client=getenv("HTTP_USER_AGENT");
if (ereg('[^(]*\((.*)\)[^)]*',$client,$regs))
{
    $os = $regs[1];
    // this looks better under WinX
    if (eregi("Win",$os)) $crlf="\r\n";
}

function my_handler($sql_insert)
{
    global $crlf;
    echo "$sql_insert;$crlf";
}

function mysql_die($error = "")
{
    global $strError;
    echo "<b> $strError </b><p>";
    if (empty($error))
        echo "MySQL replied:".mysql_error();
    else
        echo "MySQL replied:".$error;
    echo "<br><a href=\"javascript:history.go(-1)\">Back</a>";
    exit;
}

// Return $table's CREATE definition
// Returns a string containing the CREATE statement on success
function get_table_def($db, $table, $crlf)
{
    global $drop;
    $schema_create = "";
    if(!empty($drop))
    {
        $schema_create .= "DROP TABLE IF EXISTS $table;$crlf";
    }
    $schema_create .= "CREATE TABLE $table ($crlf";

    $result = mysql_db_query($db, "SHOW FIELDS FROM $table") or mysql_die();
    while ($row = mysql_fetch_array($result))
    {
       $schema_create .= "   $row[Field] $row[Type]";
       if (!empty($row["Default"]))
          {
          $schema_create .= " DEFAULT '$row[Default]'";
          }
       if ($row["Null"] != "YES")
          {
          $schema_create .= " NOT NULL";
          }
       if ($row["Extra"] != "")
          {
          $schema_create .= " $row[Extra]";
          }
       $schema_create .= ",$crlf";
    }
    $schema_create = ereg_replace(",".$crlf."$", "", $schema_create);
    $result = mysql_db_query($db, "SHOW KEYS FROM $table") or mysql_die();
    while ($row = mysql_fetch_array($result))
    {
        $kname=$row['Key_name'];
        if (($kname != "PRIMARY") && ($row['Non_unique'] == 0))
            $kname="UNIQUE|$kname";
        if(!is_array($index[$kname]))
        {
            $index[$kname] = array();
        }
        $index[$kname][] = $row['Column_name'];
    }
    while(list($x, $columns) = @each($index))
    {
        $schema_create .= ",$crlf";
        if($x == "PRIMARY")
        {
            $schema_create .= "   PRIMARY KEY (" . implode($columns, ", ") . ")";
        }
        else if (substr($x,0,6) == "UNIQUE")
        {
            $schema_create .= "   UNIQUE ".substr($x,7)." (" . implode($columns, ", ") . ")";
        }
        else
        {
            $schema_create .= "   KEY $x (" . implode($columns, ", ") . ")";
        }
    }
    $schema_create .= "$crlf)";
    return (stripslashes($schema_create));
}

// Get the content of $table as a series of INSERT statements.
// After every row, a custom callback function $handler gets called.
// $handler must accept one parameter ($sql_insert);
function get_table_content($db, $table, $handler)
{
    $result = mysql_db_query($db, "SELECT * FROM $table") or mysql_die();
    $i = 0;
    while ($row = mysql_fetch_row($result))
    {
//       set_time_limit(60); // HaRa
       $schema_insert = "INSERT INTO $table VALUES(";
       for ($j=0; $j<mysql_num_fields($result);$j++)
       {
           if (!isset($row[$j]))
           {
               $schema_insert .= " NULL,";
           }
           elseif ($row[$j] != "")
           {
               $schema_insert .= " '".addslashes($row[$j])."',";
           }
           else
           {
               $schema_insert .= " '',";
           }
       }
       $schema_insert = ereg_replace(",$", "", $schema_insert);
       $schema_insert .= ")";
       $handler(trim($schema_insert));
       $i++;
    }
    return (true);
}

$tables = mysql_list_tables($db);

$num_tables = @mysql_numrows($tables);
if ($num_tables == 0)
{
    echo $strNoTablesFound;
}
else
{
    $i = 0;
    print "# phpMyAdmin MySQL-Dump$crlf";
    print "# http://phpwizard.net/phpMyAdmin/$crlf";
    print "#$crlf";
    print "#Database: $db$crlf";

    while ($i < $num_tables)
    {
       $table = mysql_tablename($tables, $i);
       print $crlf;
       print "# --------------------------------------------------------$crlf";
       print "#$crlf";
       print "# Table Structure '$table'$crlf";
       print "#$crlf";
       print $crlf;

       echo get_table_def($db, $table, $crlf).";$crlf$crlf";
       if ($what == "data")
       {
            print "#$crlf";
            print "# Table Content '$table'$crlf";
            print "#$crlf";
            print $crlf;
            get_table_content($db, $table, "my_handler");
       }
       $i++;
   }
}
?>
