<?php
// script from emmanuel vanneau (phpMyAgenda)
// $Id: place.inc.php3, v2.0 2001/01/06 
/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function print_add_place_form($idevent) {
/* print a blank places form so we can add a new places */

	global $CFG,$ME;
	
	$frm["newmode"]     	  = "ins_place";
	$frm["nextstep"] 				= "";
	$frm["idevent"]					= $idevent;

	$frm["name"]    				= "";
	$frm["address"] 				= "";
	$frm["town"]    				= "";
	$frm["zipcode"] 				= "";
	$frm["country"] 				= "";
	$frm["contact1"] 				= "";
	$frm["contact2"] 				= "";
	$frm["contact3"] 				= "";
	$frm["contact4"] 				= "";
	$frm["contact5"] 				= "";
	$frm["contactname1"]		= "";
	$frm["contactname2"]		= "";
	$frm["contactname3"]		= "";
	$frm["contactname4"]		= "";
	$frm["contactname5"]		= "";
	$frm["url"]     				= "<select name=\"url\">"
				       							. "<option value=0> </option>"
										        . db_listbox("SELECT id, url FROM url", "0")
										        . "</select>";
	$frm["phone"]   				= "";
	$frm["fax"]     				= "";
	
	$frm["submit_caption"] 	= "Next step";
	$frm["valid"] 					= 0;
	
	include("templates/place_form.php3");
}

function print_select_place_form($idevent , $idplace = 0 , $iddate = 0) {
/* print a places list box so we can select a place */

	global $CFG,$ME;
	
	$frm["newmode"]     	  = "selected_place";
	$frm["idevent"]					= $idevent;
	$frm["iddate"]					= $iddate;
	$frm["place"]						= "<select name=\"place\">".db_listbox("SELECT id, name FROM place ORDER BY name" , $idplace)."</select>";
	$frm["submit_caption"] 	= "Next step";
	$frm["valid"] 					= 0;
	
	include("templates/place_select.php3");
}

function remove_nonvalid_places()
{
	db_query("DELETE FROM place WHERE valid=0");
 	debug("removing non valid place");
}

function get_places($id){
	
	$qid = db_query("SELECT * FROM place WHERE  id = $id");
	$frm = db_fetch_array($qid);
	return $frm;
}

function check_unique_place($frm)
{
//Check that place with fields in $frm is not present in the table
//return : 0 if not present in table
//         place.id if present

  $query = "SELECT id FROM place WHERE ";
  $query .= "name='".$frm["name"]."' AND ";
  $query .= "address='".$frm["address"]."' AND ";
  $query .= "town='".$frm["town"]."' AND ";
  $query .= "zipcode='".$frm["zipcode"]."' AND ";
  $query .= "country='".$frm["country"]."' AND ";
  $query .= "url='".$frm["url"]."' AND ";
  $query .= "phone='".$frm["phone"]."' AND ";
  $query .= "fax='".$frm["fax"]."'";
  $qid = db_query($query);
  if($row = mysql_fetch_array ($qid))
   return $row["id"];
  return 0;
}

function print_edit_places_form($id , $idevent = 0)
{
/* print a places form so we can add a edit the selected places */

  global $CFG, $ME;

  /* load up the information for the places */
  $frm = get_places($id);

  /* set values for the form */
  $frm["newmode"] = "update_place";
  $frm["idevent"] = $idevent;
  for($i=1 ; $i<=5 ; $i++)
	{
		$idc 	= $frm["contact".$i];
		$qidc = db_query("SELECT id,name FROM contacts WHERE id = $idc");
		if(db_num_rows($qidc))
		{
			$r = db_fetch_object($qidc);
   		$frm["contactname".$i]	=	$r->name;
   	}
   	else
   		$frm["contactname".$i]	=	"";
  	db_free_result($qidc);
	}
  $frm["url"]       = "<select name=\"url\">"
       							. "<option value=0> </option>"
       							. db_listbox("SELECT id, url FROM url ORDER BY url ", $frm["url"])
       							. "</select>";
  $frm["submit_caption"] = "Save Changes";

  include("templates/place_form.php3");
}

function replace_place($id)
{
// used to scan dates to get item with place=$id
// replace these items url's with 1(No url);

	$replaced = replace_in_table("date" , "place" , "$id" , "0");
	if($replaced)
		echo "<div class=normal>The place has been found in <b>$replaced events</b>. Replacing these places' url with default</div>";
}

function delete_places($id) {
	global $CFG, $ME;
	
	/* replacing this place in other tables*/
	replace_place($id);
	
	/* delete this places */
	$qid = db_query("DELETE FROM place WHERE id = $id");
}

function insert_places($frm,  $valid = "1")
{
/* add a new subplaces under the parent $id.  all the fields that we want are
 * going to in the variable $frm */

  global $CFG, $ME;
  $id = check_unique_place($frm);
  if($id)
  {
  	$frm["name"] .= " (2)";
  }

  if($frm["url"] == 0 && !empty($frm["newurl"]))
 	{
 		$frm["url"] = insert_url($frm);
 		debug("inserting url ".$frm["newurl"]." as id=".$frm["url"]);
 	}
 	
  $query = "INSERT INTO place 
  								(id, name, address, town, zipcode, country, contact1 , contact2 , contact3 , contact4 , contact5 , url, phone, fax , valid) 
  				VALUES ('', 
  				'$frm[name]', 
  				'$frm[address]', 
  				'$frm[town]', 
  				'$frm[zipcode]', 
  				'$frm[country]', 
  				'$frm[contact1]', 
  				'$frm[contact2]', 
  				'$frm[contact3]', 
  				'$frm[contact4]', 
  				'$frm[contact5]', 
  				'$frm[url]', 
  				'$frm[phone]', 
  				'$frm[fax]', 
  				'$valid')";

  $qid = db_query($query);
  return db_insert_id();
}

function update_places($id, $frm) {
/* update the places $id with new values.  all the fields that we want are
 * going to in the variable $frm */

  global $CFG, $ME;

  if($frm["url"] == 0 && !empty($frm["newurl"]))
 	{
 		$frm["url"] = insert_url($frm);
 		debug("inserting url ".$frm["newurl"]." as id=".$frm["url"]);
 	}

  $qid = db_query("
  UPDATE place SET
          name 			= '$frm[name]'
          ,address 	= '$frm[address]'
          ,town 		= '$frm[town]'
          ,zipcode 	= '$frm[zipcode]'
          ,country 	= '$frm[country]'
          ,contact1	= '$frm[contact1]'
          ,contact2	= '$frm[contact2]'
          ,contact3	= '$frm[contact3]'
          ,contact4	= '$frm[contact4]'
          ,contact5	= '$frm[contact5]'
          ,url 			= '$frm[url]'
          ,phone 		= '$frm[phone]'
          ,fax 			= '$frm[fax]'
  WHERE id = $id
  ");

}

function print_places_list($orderby="") {
/* read all the categories from the database and print them into a table.  we
 * will use a template to display the listings to keep this main script clean */

  global $CFG, $ME, $req_listplaces;
  $req_listplaces = "SELECT p.id , p.name, p.address , p.town, p.zipcode, p.country, 
             p.phone, p.fax
             FROM   place p";
  if($orderby)
   $req_listplaces .= " ORDER BY ".$orderby." ASC";
  $qid = db_query($req_listplaces);

  include("templates/places_list.php3");
}

function validate_place_form($frm , $mode)
{
  global $CFG,$ME;
 	if(empty($frm["name"]))
 	{
 		$frm["newmode"]   = $mode;
	  $frm["url"]    = "<select name=\"url\">"
	          . "<option value=0> </option>"
	          . db_listbox("SELECT id, url FROM url ORDER BY url", $frm["url"])
	          . "</select>";
	  $validation = true;
	  $id = $frm["id"];
 		include("templates/place_form.php3");
 		return false;
 	}
 	return true; 	  
}	

function	add_contact_to_place($idplace , $idcontact)
{
	// Add a contact reference to the event
	$qid = db_query("SELECT * FROM place WHERE id=$idplace");
  $r 	 = db_fetch_array($qid);
  $done= false;
  for($i=1 ; $i<=5 && !$done ; $i++)
	{
		$cid = "contact".$i;
		if($r[$cid] == 0)
		{
			db_query("UPDATE place SET $cid = $idcontact WHERE id=$idplace");
			debug("contact place # $i added");
			$done = true;
		}
  }
}

function update_contact_to_place($idplace , $idcontact , $idcontactnumber=0)
{
	$cid = "contact".$idcontactnumber;
	debug("updating $cid");
	db_query("UPDATE place SET $cid = $idcontact WHERE id=$idplace");
	debug("contact place # $idcontactnumber updated");
}

function	remove_contact_from_place($idplace , $idcontact)
{
	// remove a contact reference from the event
	$cid = "contact".$idcontact;
	db_query("UPDATE place SET $cid = 0 WHERE id=$idplace");
	debug("contact place # $idcontact remove");
}

?>