<?php
	
	// 	German traduction file. 

	// datetime format
	// Select date format for this language
	// Available option are :
	// %Y = display year (2001)
	// %M = display month (02)
	// %m = display literal month (february)
	// %D = display day (10)
	// %H = display hour in 24 hour format (00-23)
	// %h = display hour in 12 hour format (01-12) (uses $pm and $am)
	// %mi = display minutes (00-59)
	// %enddate = display end date
	// %endtime = display end date
	// %starttime = display start time
	// %startdaye = display start date 
	$pm 							= "PM";
	$am								= "AM";
	$dateformat				= "%M/%D/%Y";
	$timeformat				= "%h:%mi";
	//datestart and dateend are the same day/same hour
	$datesamestartend =	"<b>%startdate</b> at <b>%starttime</b>"; 
	// datestart and dateend are the same day
	$datesameday			=	"<b>%startdate</b> from <b>%starttime</b> to <b>%endtime</b>"; 
	// datestart and dateend are not the same day
	$dateother				= "From <b>%startdate</b> at <b>%starttime</b> to <b>%enddate</b> at <b>%endtime</b>";
	
	// welcome page
	$strAdministrator = "phpMyAgenda administrator";
	$strWelcome 			= "<b><font size='7' color='#3d769c'>W</font></b>elcome to <font color='#3d769c'>phpMyAgenda</font> administrative interface "; 
	
	// left menu
	$strLogout				= "Abmelden";
	$strCurrent				= "Angemeldet als";
	$strHome					= "Home";
	$strEvents				= "Veranstaltungen";
	$strPlaces				= "Orte";
	$strContacts			= "Kontakte";
	$strUrls					= "Urls";
	$strTypes					= "Kategorien";
	$strMaintenance 	= "Maintenance";
	$strHelp					= "Hilfe";
	$strInfo					= "Info";
	$strAccessEvent		= "Click to access to events";
	$strAccessPlace		= "Click to access to places";
	$strAccessURL			= "Click to access to URLs";
	$strAccessContact	= "Click to access to contacts";
	$strAccessType		= "Click to access to event's type";
	$strAdministrate	= "Administrate";
	$strAccessAdmin		= "Click to access to administrator interface";
	
	// administrator page
	$strNotAdmin			= "You don't have administrator privileges";
	$strAdminTitle		=	"phpMyAgenda User Administration";
	$strUserAdd			 	= "Add an user";
	$strUserList			= "> administration > users > list"; 
	$strUserEdit			= "Edit this user";
	$strUserDel				=	"Delete this user";
	$strUserForm			= "User form";
	$strLang					= "Language";
	$strLastLog				= "Last logged";
	$strPermissions		= "Permissions";
	$strActive				= "Active";
	$strUserAddBtn 		= "Validate this user";
	$strPassNotConf		= "Password not confirmed";
	$strRight					= array("admin"=>"Administrator" , "write"=>"Read / Write" , "read"=>"Read only");

	// maintenance page
	$strMaintenanceTitle = "phpMyAgenda Verwaltung";
	$strMaintenance		= "Verwaltung";
	$strBackup				= "Sichern der Daten.";
	$strBackupText		= "Dies sichert die Daten im SQL-Format.<br>Beim drcken des 'Komplett-Sicherung' Buttons, <br>wird die Datei mit den Daten auf Ihrer Festplatte gespeichert.<br><b>Diese Datei sollten Sie dann auf ein Netzlaufwerk oder Diskette speichern.</b><br>Wichtig : Es ist sehr wichtig  die Daten <b>regelmig</b> zu sichern.";
	$strBackupBtn			= "Komplett-Sicherung";
	$strRestore				= "Wiederherstellen aus Sicherung.";
	$strRestoreBtn		= "Rcksichern";
	$strRestoreText		=	"Wiederherstellung der Daten aus einer frheren Sicherung.<br><br><b>Warnung !</b><br>Dies lscht alle <b> Daten</b> die seit dem letzten Backup gendert wurden. Die Daten der Sicherung werden wiederhergestellt.<br><b>Seien Sie sehr vorsichtig mit dieser Funktion</b><br><br>Hinweis : Setzen Sie sich vorher besser mit der Abteilung IuK in Verbindung (944-328)";
	$strRestoreFile		= "Datei-Pfad: ";
	$strRestoreCon		=	"Dies ersetzt alle Daten.<br>Wollen Sie wirklich fortfahren ?";
	$strPhpInfo				= "PHP Konfiguration";
	$strPhpInfoBtn		= "Konfiguration anzeigen";
	$strPhpInfoText		= "PHP-Informationen anzeigen.";
	
	// Event 			
	$strEventTitle		= "Veranstaltungs-Management";
	$strEventList			= "> Verwaltung > Events > List ";
	$strEventFound		=	"Eintrge gefunden";
	$strEventsFound		= "Eintrge gefunden";
	$strEventDisp			= "Zeige ";
	$strEventTo				= "bis ";
	$strEventAdd			= "Neue Veranstaltung";
	$strEventNotFound = "Keine Eintrge gefunden";
	$strEventEdit			= "Eintrag bearbeiten";
	$strEventDel			=	"Eintrag lschen";
	$strEventDup			= "Eintrag duplizieren";
	$strMoreDate			= "Hat mehrere Datums...";
	$strEventForm			= "Veranstaltungs-Formular";
		
	// Filter 
	$strFilterBetween = "Zwischen";
	$strFilterSelect	= "Whlen !";

	// Common
	$strType		 			= "Art";
	$strTitle					= "Titel";
	$strAnd						= " und ";
	$strDescription		= "Beschreibung";
	$strAction				= "Aktion";
	$strPlace					= "Ort";
	$strOrganizer			= "Veranstalter";
	$strAddOrga				=	"Neuer Veranstalter";
	$strEditOrga			= "Veranstalter bearbeiten";
	$strDelOrga				=	"Veranstalter lschen";
	$strContact				= "Kontakt";
	$strAddContact		=	"Neuer Kontakt";
	$strEditContact		= "Kontakt bearbeiten";
	$strDelContact		=	"Kontakt lschen";
	$strURL						= "URL";
	$strNewURL				= "oder neue URL :";
	$strDate					= "Datum";
	$strAddDate				=	"Ort und Datum hinzufgen ";
	$strEditDate			=	"Ort und Datum bearbeiten ";
	$strDelDate				=	"Ort und Datum lschen ";
	$strNoDate				= "Kein Datum";
	$strValidate			= "Prfen";
	$strClickHere			= "Hier klicken";
	$strNextStep			= "Nchster Schritt";
	$strName    			= "Name";
	$strSurname    		= "Vorname";
	$strEmail	    		= "eMail";
  $strFunction   		= "Funktion";
  $strCompany   		= "Firma";
  $strPhone     		= "Telefon";
  $strFax    				= "Fax"; 
  $strAddress     	= "Addresse";
  $strZipcode     	= "PLZ";
  $strTown     			= "Stadt";
  $strCountry     	= "Land";
  $strProvideName		= "Sie mssen einen Namen angeben";
  $strProvideTitle	= "Sie mssen einen Titel angeben";
  $strProvideDesc		= "Sie mssen eine Beschreibung angeben";
  $strYes						= "Ja";
  $strNo						= "Nein";
	
	// Contact
	$strContactSelect	= "Kontakt whlen";
	$strContactAdd		= "Kontakt hinzufgen";
	$strContactNotInDB=	"Wenn der Kontakt nicht in der Liste ist, erstellen Sie einen neuen in der Datenbank.";
	$strContactTitle	= "Kontakt-Management";
	$strContactList		= "> Verwaltung > Kontakte > List3e ";
	$strContactEdit		= "Kontakt ndern";
	$strContactDel		=	"Kontakt lschen";
	$strContactForm		= "Kontakt-Formular";
	$strContacts			= "Kontakte";

	// Place
	$strPlaceSelect		= "Ort whlen";
	$strPlaceAdd			= "Ort hinzufgen";
	$strPlaceNotInDB	=	"Wenn der Ort nicht in der Liste ist, erstellen Sie bitte einen neuen. ";
	$strPlaceTitle		= "Orte-Management";
	$strPlaceList			= "> Verwaltung > Orte > Liste ";
	$strPlaceEdit			= "Ort ndern";
	$strPlaceDel			=	"Ort lschen";
	$strPlaceForm			= "Ort-Formular";
			
	// Date
	$strDateStart			= "Beginn";
	$strDateEnd				= "Ende";
	$strDateBlank			= "Freilassen wenn gleich";
	$strDateFormat1		=	"(TT-MM-JJJJ)";
	$strDateFormat2		= "(SS:MM)";
	$strDateError1		= "Alle Felder mssen korrekt ausgefllt werden";
	$strDateError2		= "Das End-Datum kann nicht vor dem Angangsdatum liegen";
	$strDateError3		= "Das Datum ist ungltig";
	$strDateForm			= "Datum-Formular";

	// Type
	$strTypeAdd				= "Kategorie hinzufgen";
	$strTypeTitle			= "Kategorie-Management";
	$strTypeList			= "> Verwaltung > Kategorien > Liste ";
	$strTypeEdit			= "Kategorie ndern";
	$strTypeDel				=	"Kategorie lschen";
	$strTypeAddBtn		= "Kategorie prfen";
	$strTypeForm			= "Kategorie-Formular";

	// Url
	$strUrlAdd				= "URL hinzufgen";
	$strUrlTitle			= "URL-Management";
	$strUrlList				= "> Verwaltung > URL > Liste ";
	$strUrlEdit				= "URL ndern";
	$strUrlDel				=	"URL lschen";
	$strUrlAddBtn			= "URL prfen";
	$strUrlForm				= "URL-Formular";
	
	// Legal Info
	$strInfoTitle			= "phpMyAgenda Information";
	
	// Preference
	$strPrefTitle			= "Benutzer-Einstellungen";
	$strPreference		= "Einstellungen";
	$strPassChange		= "Passwort mndern";
	$strPassOld				= "Ihr Passwort";
	$strPassNew				= "Neues Passwort";
	$strPassConfirm		= "Neues Passwort besttigen";
	$strLangChange		= "Sprache wechseln";
?>	